#include "Composed/SW_channel/SW_channelRJ.h"
char * SW_channelRJ__SharedNames[] = {"Chan1AttackList", "Chan2AttackList", "ChannelState_ch1", "ChannelState_ch2", "Channel_Init_1", "Channel_Init_2", "CleansingTrigger_ch1", "CleansingTrigger_ch2", "FR_Definition", "Mutex", "SysUpdate", "SystemPfd", "c_attackDetail_1", "c_attackDetail_2", "syncAttackSignal_1", "syncAttackSignal_2"};

SW_channelRJ::SW_channelRJ():Join("System_Join", 5, 16,SW_channelRJ__SharedNames) {
  CH1_Join = new SW_channelRJ__CH1_Join();
  ModelArray[0] = (BaseModelClass*) CH1_Join;
  ModelArray[0]->DefineName("CH1_Join");
  CH2_Join = new SW_channelRJ__CH2_Join();
  ModelArray[1] = (BaseModelClass*) CH2_Join;
  ModelArray[1]->DefineName("CH2_Join");
  CleansingModel1 = new CleansingModelSAN();
  ModelArray[2] = (BaseModelClass*) CleansingModel1;
  ModelArray[2]->DefineName("CleansingModel1");
  system_state1 = new system_stateSAN();
  ModelArray[3] = (BaseModelClass*) system_state1;
  ModelArray[3]->DefineName("system_state1");
  IDS_IPS_model = new IDS_IPS_modelSAN();
  ModelArray[4] = (BaseModelClass*) IDS_IPS_model;
  ModelArray[4]->DefineName("IDS_IPS_model");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    Chan1AttackList = new ChannelAttackList("Chan1AttackList");
    addSharedPtr(Chan1AttackList, "Chan1AttackList" );
    if (CH1_Join->NumStateVariables > 0) {
      Chan1AttackList->ShareWith(CH1_Join->ListOfAttacks);
      addSharingInfo(CH1_Join->ListOfAttacks, Chan1AttackList, CH1_Join);
    }
    if (system_state1->NumStateVariables > 0) {
      Chan1AttackList->ShareWith(system_state1->Ch1_attack_list);
      addSharingInfo(system_state1->Ch1_attack_list, Chan1AttackList, system_state1);
    }
    if (IDS_IPS_model->NumStateVariables > 0) {
      Chan1AttackList->ShareWith(IDS_IPS_model->Chan1AttackList);
      addSharingInfo(IDS_IPS_model->Chan1AttackList, Chan1AttackList, IDS_IPS_model);
    }

    //Shared variable 1
    Chan2AttackList = new ChannelAttackList("Chan2AttackList");
    addSharedPtr(Chan2AttackList, "Chan2AttackList" );
    if (CH2_Join->NumStateVariables > 0) {
      Chan2AttackList->ShareWith(CH2_Join->ListOfAttacks);
      addSharingInfo(CH2_Join->ListOfAttacks, Chan2AttackList, CH2_Join);
    }
    if (system_state1->NumStateVariables > 0) {
      Chan2AttackList->ShareWith(system_state1->Ch2_attack_list);
      addSharingInfo(system_state1->Ch2_attack_list, Chan2AttackList, system_state1);
    }
    if (IDS_IPS_model->NumStateVariables > 0) {
      Chan2AttackList->ShareWith(IDS_IPS_model->Chan2AttackList);
      addSharingInfo(IDS_IPS_model->Chan2AttackList, Chan2AttackList, IDS_IPS_model);
    }

    //Shared variable 2
    ChannelState_ch1 = new channelState("ChannelState_ch1");
    addSharedPtr(ChannelState_ch1, "ChannelState_ch1" );
    if (CH1_Join->NumStateVariables > 0) {
      ChannelState_ch1->ShareWith(CH1_Join->ChannelState_ch1);
      addSharingInfo(CH1_Join->ChannelState_ch1, ChannelState_ch1, CH1_Join);
    }
    if (system_state1->NumStateVariables > 0) {
      ChannelState_ch1->ShareWith(system_state1->Ch1_State);
      addSharingInfo(system_state1->Ch1_State, ChannelState_ch1, system_state1);
    }

    //Shared variable 3
    ChannelState_ch2 = new channelState("ChannelState_ch2");
    addSharedPtr(ChannelState_ch2, "ChannelState_ch2" );
    if (CH2_Join->NumStateVariables > 0) {
      ChannelState_ch2->ShareWith(CH2_Join->ChannelState_ch2);
      addSharingInfo(CH2_Join->ChannelState_ch2, ChannelState_ch2, CH2_Join);
    }
    if (system_state1->NumStateVariables > 0) {
      ChannelState_ch2->ShareWith(system_state1->Ch2_State);
      addSharingInfo(system_state1->Ch2_State, ChannelState_ch2, system_state1);
    }

    //Shared variable 4
    Channel_Init_1 = new Place("Channel_Init_1");
    addSharedPtr(Channel_Init_1, "Channel_Init_1" );
    if (CH1_Join->NumStateVariables > 0) {
      Channel_Init_1->ShareWith(CH1_Join->Channel_Init_1);
      addSharingInfo(CH1_Join->Channel_Init_1, Channel_Init_1, CH1_Join);
    }
    if (system_state1->NumStateVariables > 0) {
      Channel_Init_1->ShareWith(system_state1->Init_Ch1);
      addSharingInfo(system_state1->Init_Ch1, Channel_Init_1, system_state1);
    }

    //Shared variable 5
    Channel_Init_2 = new Place("Channel_Init_2");
    addSharedPtr(Channel_Init_2, "Channel_Init_2" );
    if (CH2_Join->NumStateVariables > 0) {
      Channel_Init_2->ShareWith(CH2_Join->Channel_Init_2);
      addSharingInfo(CH2_Join->Channel_Init_2, Channel_Init_2, CH2_Join);
    }
    if (system_state1->NumStateVariables > 0) {
      Channel_Init_2->ShareWith(system_state1->Init_Ch2);
      addSharingInfo(system_state1->Init_Ch2, Channel_Init_2, system_state1);
    }

    //Shared variable 6
    CleansingTrigger_ch1 = new Place("CleansingTrigger_ch1");
    addSharedPtr(CleansingTrigger_ch1, "CleansingTrigger_ch1" );
    if (CH1_Join->NumStateVariables > 0) {
      CleansingTrigger_ch1->ShareWith(CH1_Join->CleansingTrigger_ch1);
      addSharingInfo(CH1_Join->CleansingTrigger_ch1, CleansingTrigger_ch1, CH1_Join);
    }
    if (CleansingModel1->NumStateVariables > 0) {
      CleansingTrigger_ch1->ShareWith(CleansingModel1->Cleansing_1);
      addSharingInfo(CleansingModel1->Cleansing_1, CleansingTrigger_ch1, CleansingModel1);
    }

    //Shared variable 7
    CleansingTrigger_ch2 = new Place("CleansingTrigger_ch2");
    addSharedPtr(CleansingTrigger_ch2, "CleansingTrigger_ch2" );
    if (CH2_Join->NumStateVariables > 0) {
      CleansingTrigger_ch2->ShareWith(CH2_Join->CleansingTrigger_ch2);
      addSharingInfo(CH2_Join->CleansingTrigger_ch2, CleansingTrigger_ch2, CH2_Join);
    }
    if (CleansingModel1->NumStateVariables > 0) {
      CleansingTrigger_ch2->ShareWith(CleansingModel1->Cleansing_2);
      addSharingInfo(CleansingModel1->Cleansing_2, CleansingTrigger_ch2, CleansingModel1);
    }

    //Shared variable 8
    FR_Definition = new FR_Array("FR_Definition");
    addSharedPtr(FR_Definition, "FR_Definition" );
    if (CH1_Join->NumStateVariables > 0) {
      FR_Definition->ShareWith(CH1_Join->FR_Definition);
      addSharingInfo(CH1_Join->FR_Definition, FR_Definition, CH1_Join);
    }
    if (CH2_Join->NumStateVariables > 0) {
      FR_Definition->ShareWith(CH2_Join->FR_Definition);
      addSharingInfo(CH2_Join->FR_Definition, FR_Definition, CH2_Join);
    }
    if (system_state1->NumStateVariables > 0) {
      FR_Definition->ShareWith(system_state1->FR_Definition);
      addSharingInfo(system_state1->FR_Definition, FR_Definition, system_state1);
    }

    //Shared variable 9
    Mutex = new Place("Mutex");
    addSharedPtr(Mutex, "Mutex" );
    if (CH1_Join->NumStateVariables > 0) {
      Mutex->ShareWith(CH1_Join->Mutex);
      addSharingInfo(CH1_Join->Mutex, Mutex, CH1_Join);
    }
    if (CH2_Join->NumStateVariables > 0) {
      Mutex->ShareWith(CH2_Join->Mutex);
      addSharingInfo(CH2_Join->Mutex, Mutex, CH2_Join);
    }
    if (system_state1->NumStateVariables > 0) {
      Mutex->ShareWith(system_state1->Mutex);
      addSharingInfo(system_state1->Mutex, Mutex, system_state1);
    }

    //Shared variable 10
    SysUpdate = new Place("SysUpdate");
    addSharedPtr(SysUpdate, "SysUpdate" );
    if (CH1_Join->NumStateVariables > 0) {
      SysUpdate->ShareWith(CH1_Join->SystemStateUpdate);
      addSharingInfo(CH1_Join->SystemStateUpdate, SysUpdate, CH1_Join);
    }
    if (CH2_Join->NumStateVariables > 0) {
      SysUpdate->ShareWith(CH2_Join->SystemStateUpdate);
      addSharingInfo(CH2_Join->SystemStateUpdate, SysUpdate, CH2_Join);
    }
    if (system_state1->NumStateVariables > 0) {
      SysUpdate->ShareWith(system_state1->SysUpdate);
      addSharingInfo(system_state1->SysUpdate, SysUpdate, system_state1);
    }

    //Shared variable 11
    SystemPfd = new ExtendedPlace<double>("SystemPfd");
    addSharedPtr(SystemPfd, "SystemPfd" );
    if (system_state1->NumStateVariables > 0) {
      SystemPfd->ShareWith(system_state1->SystemPfd);
      addSharingInfo(system_state1->SystemPfd, SystemPfd, system_state1);
    }

    //Shared variable 12
    c_attackDetail_1 = new channelAttack("c_attackDetail_1");
    addSharedPtr(c_attackDetail_1, "c_attackDetail_1" );
    if (CH1_Join->NumStateVariables > 0) {
      c_attackDetail_1->ShareWith(CH1_Join->c_attackDetail_1);
      addSharingInfo(CH1_Join->c_attackDetail_1, c_attackDetail_1, CH1_Join);
    }
    if (CH2_Join->NumStateVariables > 0) {
      c_attackDetail_1->ShareWith(CH2_Join->copyAttackDetail_2);
      addSharingInfo(CH2_Join->copyAttackDetail_2, c_attackDetail_1, CH2_Join);
    }

    //Shared variable 13
    c_attackDetail_2 = new channelAttack("c_attackDetail_2");
    addSharedPtr(c_attackDetail_2, "c_attackDetail_2" );
    if (CH1_Join->NumStateVariables > 0) {
      c_attackDetail_2->ShareWith(CH1_Join->copyAttackDetail_1);
      addSharingInfo(CH1_Join->copyAttackDetail_1, c_attackDetail_2, CH1_Join);
    }
    if (CH2_Join->NumStateVariables > 0) {
      c_attackDetail_2->ShareWith(CH2_Join->c_attackDetail_2);
      addSharingInfo(CH2_Join->c_attackDetail_2, c_attackDetail_2, CH2_Join);
    }

    //Shared variable 14
    syncAttackSignal_1 = new Place("syncAttackSignal_1");
    addSharedPtr(syncAttackSignal_1, "syncAttackSignal_1" );
    if (CH1_Join->NumStateVariables > 0) {
      syncAttackSignal_1->ShareWith(CH1_Join->syncAttackSignal_1);
      addSharingInfo(CH1_Join->syncAttackSignal_1, syncAttackSignal_1, CH1_Join);
    }
    if (CH2_Join->NumStateVariables > 0) {
      syncAttackSignal_1->ShareWith(CH2_Join->syncroAttack_occurred_2);
      addSharingInfo(CH2_Join->syncroAttack_occurred_2, syncAttackSignal_1, CH2_Join);
    }

    //Shared variable 15
    syncAttackSignal_2 = new Place("syncAttackSignal_2");
    addSharedPtr(syncAttackSignal_2, "syncAttackSignal_2" );
    if (CH1_Join->NumStateVariables > 0) {
      syncAttackSignal_2->ShareWith(CH1_Join->syncroAttack_occurred_1);
      addSharingInfo(CH1_Join->syncroAttack_occurred_1, syncAttackSignal_2, CH1_Join);
    }
    if (CH2_Join->NumStateVariables > 0) {
      syncAttackSignal_2->ShareWith(CH2_Join->syncAttackSignal_2);
      addSharingInfo(CH2_Join->syncAttackSignal_2, syncAttackSignal_2, CH2_Join);
    }

  }

  Setup();
}

SW_channelRJ::~SW_channelRJ() {
  if (!AllChildrenEmpty()) {
    delete Chan1AttackList;
    delete Chan2AttackList;
    delete ChannelState_ch1;
    delete ChannelState_ch2;
    delete Channel_Init_1;
    delete Channel_Init_2;
    delete CleansingTrigger_ch1;
    delete CleansingTrigger_ch2;
    delete FR_Definition;
    delete Mutex;
    delete SysUpdate;
    delete SystemPfd;
    delete c_attackDetail_1;
    delete c_attackDetail_2;
    delete syncAttackSignal_1;
    delete syncAttackSignal_2;
  }
  delete CH1_Join;
  delete CH2_Join;
  delete CleansingModel1;
  delete system_state1;
  delete IDS_IPS_model;
}
