#ifndef SW_channelRJ_H_
#define SW_channelRJ_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/SW_channel/SW_channelRJ__CH1_Join.h"
#include "Composed/SW_channel/SW_channelRJ__CH2_Join.h"
#include "Atomic/CleansingModel/CleansingModelSAN.h"
#include "Atomic/system_state/system_stateSAN.h"
#include "Atomic/IDS_IPS_model/IDS_IPS_modelSAN.h"

//State variable headers
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern short demand_types_ch1;
extern short demand_types_ch2;

class SW_channelRJ: public Join {
 public:
  SW_channelRJ__CH1_Join * CH1_Join;
  SW_channelRJ__CH2_Join * CH2_Join;
  CleansingModelSAN * CleansingModel1;
  system_stateSAN * system_state1;
  IDS_IPS_modelSAN * IDS_IPS_model;
  ChannelAttackList * Chan1AttackList;
  ChannelAttackList * Chan2AttackList;
  channelState * ChannelState_ch1;
  channelState * ChannelState_ch2;
  Place * Channel_Init_1;
  Place * Channel_Init_2;
  Place * CleansingTrigger_ch1;
  Place * CleansingTrigger_ch2;
  FR_Array * FR_Definition;
  Place * Mutex;
  Place * SysUpdate;
  ExtendedPlace<double> * SystemPfd;
  channelAttack * c_attackDetail_1;
  channelAttack * c_attackDetail_2;
  Place * syncAttackSignal_1;
  Place * syncAttackSignal_2;

  SW_channelRJ();
  ~SW_channelRJ();
};

#endif
