#include "Composed/SW_channel/SW_channelRJ__CH1_Join.h"
char * SW_channelRJ__CH1_Join__SharedNames[] = {"ChannelState_ch1", "Channel_ID_1", "Channel_Init_1", "CleansingTrigger_ch1", "FR_Definition", "InitTokens", "Input", "ListOfAttacks", "Mutex", "SystemStateUpdate", "c_attackDetail_1", "channel_initialised_1", "copyAttackDetail_1", "maxDemands", "successful_attack_occured", "syncAttackSignal_1", "syncroAttack_occurred_1"};

SW_channelRJ__CH1_Join::SW_channelRJ__CH1_Join():Join("CH1_Join", 3, 17,SW_channelRJ__CH1_Join__SharedNames) {
  Rep1 = new SW_channelRJ__Rep1();
  ModelArray[0] = (BaseModelClass*) Rep1;
  ModelArray[0]->DefineName("Rep1");
  software_channel = new software_channelSAN();
  ModelArray[1] = (BaseModelClass*) software_channel;
  ModelArray[1]->DefineName("software_channel");
  Ch1_Attack_Evolution = new Attack_EvolutionSAN();
  ModelArray[2] = (BaseModelClass*) Ch1_Attack_Evolution;
  ModelArray[2]->DefineName("Ch1_Attack_Evolution");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    ChannelState_ch1 = new channelState("ChannelState_ch1");
    addSharedPtr(ChannelState_ch1, "ChannelState_ch1" );
    if (software_channel->NumStateVariables > 0) {
      ChannelState_ch1->ShareWith(software_channel->ChannelState);
      addSharingInfo(software_channel->ChannelState, ChannelState_ch1, software_channel);
    }

    //Shared variable 1
    Channel_ID_1 = new Place("Channel_ID_1");
    addSharedPtr(Channel_ID_1, "Channel_ID_1" );
    if (Rep1->NumStateVariables > 0) {
      Channel_ID_1->ShareWith(Rep1->Channel_ID);
      addSharingInfo(Rep1->Channel_ID, Channel_ID_1, Rep1);
    }
    if (software_channel->NumStateVariables > 0) {
      Channel_ID_1->ShareWith(software_channel->ChannelState->channel_ID);
      addSharingInfo(software_channel->ChannelState->channel_ID, Channel_ID_1, software_channel);
    }

    //Shared variable 2
    Channel_Init_1 = new Place("Channel_Init_1");
    addSharedPtr(Channel_Init_1, "Channel_Init_1" );
    if (software_channel->NumStateVariables > 0) {
      Channel_Init_1->ShareWith(software_channel->Channel_Init);
      addSharingInfo(software_channel->Channel_Init, Channel_Init_1, software_channel);
    }

    //Shared variable 3
    CleansingTrigger_ch1 = new Place("CleansingTrigger_ch1");
    addSharedPtr(CleansingTrigger_ch1, "CleansingTrigger_ch1" );
    if (software_channel->NumStateVariables > 0) {
      CleansingTrigger_ch1->ShareWith(software_channel->CleansingTriggered);
      addSharingInfo(software_channel->CleansingTriggered, CleansingTrigger_ch1, software_channel);
    }

    //Shared variable 4
    FR_Definition = new FR_Array("FR_Definition");
    addSharedPtr(FR_Definition, "FR_Definition" );
    if (software_channel->NumStateVariables > 0) {
      FR_Definition->ShareWith(software_channel->FR_Definition);
      addSharingInfo(software_channel->FR_Definition, FR_Definition, software_channel);
    }

    //Shared variable 5
    InitTokens = new Place("InitTokens");
    addSharedPtr(InitTokens, "InitTokens" );
    if (Rep1->NumStateVariables > 0) {
      InitTokens->ShareWith(Rep1->InitTokens);
      addSharingInfo(Rep1->InitTokens, InitTokens, Rep1);
    }
    if (software_channel->NumStateVariables > 0) {
      InitTokens->ShareWith(software_channel->initTokens);
      addSharingInfo(software_channel->initTokens, InitTokens, software_channel);
    }

    //Shared variable 6
    Input = new channelAttack("Input");
    addSharedPtr(Input, "Input" );
    if (Rep1->NumStateVariables > 0) {
      Input->ShareWith(Rep1->Input);
      addSharingInfo(Rep1->Input, Input, Rep1);
    }
    if (software_channel->NumStateVariables > 0) {
      Input->ShareWith(software_channel->attackDetail);
      addSharingInfo(software_channel->attackDetail, Input, software_channel);
    }

    //Shared variable 7
    ListOfAttacks = new ChannelAttackList("ListOfAttacks");
    addSharedPtr(ListOfAttacks, "ListOfAttacks" );
    if (Rep1->NumStateVariables > 0) {
      ListOfAttacks->ShareWith(Rep1->ListOfAttacks);
      addSharingInfo(Rep1->ListOfAttacks, ListOfAttacks, Rep1);
    }
    if (software_channel->NumStateVariables > 0) {
      ListOfAttacks->ShareWith(software_channel->ChanAttackList);
      addSharingInfo(software_channel->ChanAttackList, ListOfAttacks, software_channel);
    }
    if (Ch1_Attack_Evolution->NumStateVariables > 0) {
      ListOfAttacks->ShareWith(Ch1_Attack_Evolution->ChanAttackList);
      addSharingInfo(Ch1_Attack_Evolution->ChanAttackList, ListOfAttacks, Ch1_Attack_Evolution);
    }

    //Shared variable 8
    Mutex = new Place("Mutex");
    addSharedPtr(Mutex, "Mutex" );
    if (software_channel->NumStateVariables > 0) {
      Mutex->ShareWith(software_channel->Mutex);
      addSharingInfo(software_channel->Mutex, Mutex, software_channel);
    }

    //Shared variable 9
    SystemStateUpdate = new Place("SystemStateUpdate");
    addSharedPtr(SystemStateUpdate, "SystemStateUpdate" );
    if (software_channel->NumStateVariables > 0) {
      SystemStateUpdate->ShareWith(software_channel->SystemStateUpdate);
      addSharingInfo(software_channel->SystemStateUpdate, SystemStateUpdate, software_channel);
    }

    //Shared variable 10
    c_attackDetail_1 = new channelAttack("c_attackDetail_1");
    addSharedPtr(c_attackDetail_1, "c_attackDetail_1" );
    if (software_channel->NumStateVariables > 0) {
      c_attackDetail_1->ShareWith(software_channel->c_attackDetail);
      addSharingInfo(software_channel->c_attackDetail, c_attackDetail_1, software_channel);
    }

    //Shared variable 11
    channel_initialised_1 = new Place("channel_initialised_1");
    addSharedPtr(channel_initialised_1, "channel_initialised_1" );
    if (Rep1->NumStateVariables > 0) {
      channel_initialised_1->ShareWith(Rep1->channel_initialised);
      addSharingInfo(Rep1->channel_initialised, channel_initialised_1, Rep1);
    }
    if (software_channel->NumStateVariables > 0) {
      channel_initialised_1->ShareWith(software_channel->Initialised_counter);
      addSharingInfo(software_channel->Initialised_counter, channel_initialised_1, software_channel);
    }

    //Shared variable 12
    copyAttackDetail_1 = new channelAttack("copyAttackDetail_1");
    addSharedPtr(copyAttackDetail_1, "copyAttackDetail_1" );
    if (software_channel->NumStateVariables > 0) {
      copyAttackDetail_1->ShareWith(software_channel->copyAttackDetail);
      addSharingInfo(software_channel->copyAttackDetail, copyAttackDetail_1, software_channel);
    }

    //Shared variable 13
    maxDemands = new Place("maxDemands");
    addSharedPtr(maxDemands, "maxDemands" );
    if (Rep1->NumStateVariables > 0) {
      maxDemands->ShareWith(Rep1->maxDemands);
      addSharingInfo(Rep1->maxDemands, maxDemands, Rep1);
    }
    if (software_channel->NumStateVariables > 0) {
      maxDemands->ShareWith(software_channel->maxDemands);
      addSharingInfo(software_channel->maxDemands, maxDemands, software_channel);
    }

    //Shared variable 14
    successful_attack_occured = new Place("successful_attack_occured");
    addSharedPtr(successful_attack_occured, "successful_attack_occured" );
    if (Rep1->NumStateVariables > 0) {
      successful_attack_occured->ShareWith(Rep1->DemandSubmitted);
      addSharingInfo(Rep1->DemandSubmitted, successful_attack_occured, Rep1);
    }
    if (software_channel->NumStateVariables > 0) {
      successful_attack_occured->ShareWith(software_channel->successful_attack_occured);
      addSharingInfo(software_channel->successful_attack_occured, successful_attack_occured, software_channel);
    }

    //Shared variable 15
    syncAttackSignal_1 = new Place("syncAttackSignal_1");
    addSharedPtr(syncAttackSignal_1, "syncAttackSignal_1" );
    if (software_channel->NumStateVariables > 0) {
      syncAttackSignal_1->ShareWith(software_channel->syncAttackSignal);
      addSharingInfo(software_channel->syncAttackSignal, syncAttackSignal_1, software_channel);
    }

    //Shared variable 16
    syncroAttack_occurred_1 = new Place("syncroAttack_occurred_1");
    addSharedPtr(syncroAttack_occurred_1, "syncroAttack_occurred_1" );
    if (software_channel->NumStateVariables > 0) {
      syncroAttack_occurred_1->ShareWith(software_channel->syncroAttack_occurred);
      addSharingInfo(software_channel->syncroAttack_occurred, syncroAttack_occurred_1, software_channel);
    }

  }

  Setup();
}

SW_channelRJ__CH1_Join::~SW_channelRJ__CH1_Join() {
  if (!AllChildrenEmpty()) {
    delete ChannelState_ch1;
    delete Channel_ID_1;
    delete Channel_Init_1;
    delete CleansingTrigger_ch1;
    delete FR_Definition;
    delete InitTokens;
    delete Input;
    delete ListOfAttacks;
    delete Mutex;
    delete SystemStateUpdate;
    delete c_attackDetail_1;
    delete channel_initialised_1;
    delete copyAttackDetail_1;
    delete maxDemands;
    delete successful_attack_occured;
    delete syncAttackSignal_1;
    delete syncroAttack_occurred_1;
  }
  delete Rep1;
  delete software_channel;
  delete Ch1_Attack_Evolution;
}
