#include "Composed/SW_channel/SW_channelRJ__CH2_Join.h"
char * SW_channelRJ__CH2_Join__SharedNames[] = {"ChannelState_ch2", "Channel_ID_2", "Channel_Init_2", "CleansingTrigger_ch2", "FR_Definition", "InitTokens", "Input", "ListOfAttacks", "Mutex", "SystemStateUpdate", "c_attackDetail_2", "channel_initialised_2", "copyAttackDetail_2", "maxDemands", "successful_attack_occured", "syncAttackSignal_2", "syncroAttack_occurred_2"};

SW_channelRJ__CH2_Join::SW_channelRJ__CH2_Join():Join("CH2_Join", 3, 17,SW_channelRJ__CH2_Join__SharedNames) {
  Rep2 = new SW_channelRJ__Rep2();
  ModelArray[0] = (BaseModelClass*) Rep2;
  ModelArray[0]->DefineName("Rep2");
  software_channel_2 = new software_channelSAN();
  ModelArray[1] = (BaseModelClass*) software_channel_2;
  ModelArray[1]->DefineName("software_channel_2");
  Ch2_Attack_Evolution = new Attack_EvolutionSAN();
  ModelArray[2] = (BaseModelClass*) Ch2_Attack_Evolution;
  ModelArray[2]->DefineName("Ch2_Attack_Evolution");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    ChannelState_ch2 = new channelState("ChannelState_ch2");
    addSharedPtr(ChannelState_ch2, "ChannelState_ch2" );
    if (software_channel_2->NumStateVariables > 0) {
      ChannelState_ch2->ShareWith(software_channel_2->ChannelState);
      addSharingInfo(software_channel_2->ChannelState, ChannelState_ch2, software_channel_2);
    }

    //Shared variable 1
    Channel_ID_2 = new Place("Channel_ID_2");
    addSharedPtr(Channel_ID_2, "Channel_ID_2" );
    if (Rep2->NumStateVariables > 0) {
      Channel_ID_2->ShareWith(Rep2->Channel_ID);
      addSharingInfo(Rep2->Channel_ID, Channel_ID_2, Rep2);
    }
    if (software_channel_2->NumStateVariables > 0) {
      Channel_ID_2->ShareWith(software_channel_2->ChannelState->channel_ID);
      addSharingInfo(software_channel_2->ChannelState->channel_ID, Channel_ID_2, software_channel_2);
    }

    //Shared variable 2
    Channel_Init_2 = new Place("Channel_Init_2");
    addSharedPtr(Channel_Init_2, "Channel_Init_2" );
    if (software_channel_2->NumStateVariables > 0) {
      Channel_Init_2->ShareWith(software_channel_2->Channel_Init);
      addSharingInfo(software_channel_2->Channel_Init, Channel_Init_2, software_channel_2);
    }

    //Shared variable 3
    CleansingTrigger_ch2 = new Place("CleansingTrigger_ch2");
    addSharedPtr(CleansingTrigger_ch2, "CleansingTrigger_ch2" );
    if (software_channel_2->NumStateVariables > 0) {
      CleansingTrigger_ch2->ShareWith(software_channel_2->CleansingTriggered);
      addSharingInfo(software_channel_2->CleansingTriggered, CleansingTrigger_ch2, software_channel_2);
    }

    //Shared variable 4
    FR_Definition = new FR_Array("FR_Definition");
    addSharedPtr(FR_Definition, "FR_Definition" );
    if (software_channel_2->NumStateVariables > 0) {
      FR_Definition->ShareWith(software_channel_2->FR_Definition);
      addSharingInfo(software_channel_2->FR_Definition, FR_Definition, software_channel_2);
    }

    //Shared variable 5
    InitTokens = new Place("InitTokens");
    addSharedPtr(InitTokens, "InitTokens" );
    if (Rep2->NumStateVariables > 0) {
      InitTokens->ShareWith(Rep2->InitTokens);
      addSharingInfo(Rep2->InitTokens, InitTokens, Rep2);
    }
    if (software_channel_2->NumStateVariables > 0) {
      InitTokens->ShareWith(software_channel_2->initTokens);
      addSharingInfo(software_channel_2->initTokens, InitTokens, software_channel_2);
    }

    //Shared variable 6
    Input = new channelAttack("Input");
    addSharedPtr(Input, "Input" );
    if (Rep2->NumStateVariables > 0) {
      Input->ShareWith(Rep2->Input);
      addSharingInfo(Rep2->Input, Input, Rep2);
    }
    if (software_channel_2->NumStateVariables > 0) {
      Input->ShareWith(software_channel_2->attackDetail);
      addSharingInfo(software_channel_2->attackDetail, Input, software_channel_2);
    }

    //Shared variable 7
    ListOfAttacks = new ChannelAttackList("ListOfAttacks");
    addSharedPtr(ListOfAttacks, "ListOfAttacks" );
    if (Rep2->NumStateVariables > 0) {
      ListOfAttacks->ShareWith(Rep2->ListOfAttacks);
      addSharingInfo(Rep2->ListOfAttacks, ListOfAttacks, Rep2);
    }
    if (software_channel_2->NumStateVariables > 0) {
      ListOfAttacks->ShareWith(software_channel_2->ChanAttackList);
      addSharingInfo(software_channel_2->ChanAttackList, ListOfAttacks, software_channel_2);
    }
    if (Ch2_Attack_Evolution->NumStateVariables > 0) {
      ListOfAttacks->ShareWith(Ch2_Attack_Evolution->ChanAttackList);
      addSharingInfo(Ch2_Attack_Evolution->ChanAttackList, ListOfAttacks, Ch2_Attack_Evolution);
    }

    //Shared variable 8
    Mutex = new Place("Mutex");
    addSharedPtr(Mutex, "Mutex" );
    if (software_channel_2->NumStateVariables > 0) {
      Mutex->ShareWith(software_channel_2->Mutex);
      addSharingInfo(software_channel_2->Mutex, Mutex, software_channel_2);
    }

    //Shared variable 9
    SystemStateUpdate = new Place("SystemStateUpdate");
    addSharedPtr(SystemStateUpdate, "SystemStateUpdate" );
    if (software_channel_2->NumStateVariables > 0) {
      SystemStateUpdate->ShareWith(software_channel_2->SystemStateUpdate);
      addSharingInfo(software_channel_2->SystemStateUpdate, SystemStateUpdate, software_channel_2);
    }

    //Shared variable 10
    c_attackDetail_2 = new channelAttack("c_attackDetail_2");
    addSharedPtr(c_attackDetail_2, "c_attackDetail_2" );
    if (software_channel_2->NumStateVariables > 0) {
      c_attackDetail_2->ShareWith(software_channel_2->c_attackDetail);
      addSharingInfo(software_channel_2->c_attackDetail, c_attackDetail_2, software_channel_2);
    }

    //Shared variable 11
    channel_initialised_2 = new Place("channel_initialised_2");
    addSharedPtr(channel_initialised_2, "channel_initialised_2" );
    if (Rep2->NumStateVariables > 0) {
      channel_initialised_2->ShareWith(Rep2->channel_initialised);
      addSharingInfo(Rep2->channel_initialised, channel_initialised_2, Rep2);
    }
    if (software_channel_2->NumStateVariables > 0) {
      channel_initialised_2->ShareWith(software_channel_2->Initialised_counter);
      addSharingInfo(software_channel_2->Initialised_counter, channel_initialised_2, software_channel_2);
    }

    //Shared variable 12
    copyAttackDetail_2 = new channelAttack("copyAttackDetail_2");
    addSharedPtr(copyAttackDetail_2, "copyAttackDetail_2" );
    if (software_channel_2->NumStateVariables > 0) {
      copyAttackDetail_2->ShareWith(software_channel_2->copyAttackDetail);
      addSharingInfo(software_channel_2->copyAttackDetail, copyAttackDetail_2, software_channel_2);
    }

    //Shared variable 13
    maxDemands = new Place("maxDemands");
    addSharedPtr(maxDemands, "maxDemands" );
    if (Rep2->NumStateVariables > 0) {
      maxDemands->ShareWith(Rep2->maxDemands);
      addSharingInfo(Rep2->maxDemands, maxDemands, Rep2);
    }
    if (software_channel_2->NumStateVariables > 0) {
      maxDemands->ShareWith(software_channel_2->maxDemands);
      addSharingInfo(software_channel_2->maxDemands, maxDemands, software_channel_2);
    }

    //Shared variable 14
    successful_attack_occured = new Place("successful_attack_occured");
    addSharedPtr(successful_attack_occured, "successful_attack_occured" );
    if (Rep2->NumStateVariables > 0) {
      successful_attack_occured->ShareWith(Rep2->DemandSubmitted);
      addSharingInfo(Rep2->DemandSubmitted, successful_attack_occured, Rep2);
    }
    if (software_channel_2->NumStateVariables > 0) {
      successful_attack_occured->ShareWith(software_channel_2->successful_attack_occured);
      addSharingInfo(software_channel_2->successful_attack_occured, successful_attack_occured, software_channel_2);
    }

    //Shared variable 15
    syncAttackSignal_2 = new Place("syncAttackSignal_2");
    addSharedPtr(syncAttackSignal_2, "syncAttackSignal_2" );
    if (software_channel_2->NumStateVariables > 0) {
      syncAttackSignal_2->ShareWith(software_channel_2->syncAttackSignal);
      addSharingInfo(software_channel_2->syncAttackSignal, syncAttackSignal_2, software_channel_2);
    }

    //Shared variable 16
    syncroAttack_occurred_2 = new Place("syncroAttack_occurred_2");
    addSharedPtr(syncroAttack_occurred_2, "syncroAttack_occurred_2" );
    if (software_channel_2->NumStateVariables > 0) {
      syncroAttack_occurred_2->ShareWith(software_channel_2->syncroAttack_occurred);
      addSharingInfo(software_channel_2->syncroAttack_occurred, syncroAttack_occurred_2, software_channel_2);
    }

  }

  Setup();
}

SW_channelRJ__CH2_Join::~SW_channelRJ__CH2_Join() {
  if (!AllChildrenEmpty()) {
    delete ChannelState_ch2;
    delete Channel_ID_2;
    delete Channel_Init_2;
    delete CleansingTrigger_ch2;
    delete FR_Definition;
    delete InitTokens;
    delete Input;
    delete ListOfAttacks;
    delete Mutex;
    delete SystemStateUpdate;
    delete c_attackDetail_2;
    delete channel_initialised_2;
    delete copyAttackDetail_2;
    delete maxDemands;
    delete successful_attack_occured;
    delete syncAttackSignal_2;
    delete syncroAttack_occurred_2;
  }
  delete Rep2;
  delete software_channel_2;
  delete Ch2_Attack_Evolution;
}
