#include "Composed/SW_channel/SW_channelRJ__Rep1.h"
char * SW_channelRJ__Rep1__SharedNames[] = {"Channel_ID", "DemandSubmitted", "InitTokens", "Input", "ListOfAttacks", "channel_initialised", "maxDemands"};

SW_channelRJ__Rep1::SW_channelRJ__Rep1():Rep("Rep1", demand_types_max, 7, SW_channelRJ__Rep1__SharedNames)
{
  InstanceArray = new Malicious_Demands_InitSAN * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new Malicious_Demands_InitSAN();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************** Initialize local variables ****************
    Channel_ID = new Place("Channel_ID");
    addSharedPtr(Channel_ID, "Channel_ID");
    Channel_ID->ShareWith(InstanceArray[0]->Channel_ID);

    DemandSubmitted = new Place("DemandSubmitted");
    addSharedPtr(DemandSubmitted, "DemandSubmitted");
    DemandSubmitted->ShareWith(InstanceArray[0]->DemandSubmitted);

    InitTokens = new Place("InitTokens");
    addSharedPtr(InitTokens, "InitTokens");
    InitTokens->ShareWith(InstanceArray[0]->InitTokens);

    Input = new channelAttack("Input");
    addSharedPtr(Input, "Input");
    Input->ShareWith(InstanceArray[0]->Input);

    ListOfAttacks = new ChannelAttackList("ListOfAttacks");
    addSharedPtr(ListOfAttacks, "ListOfAttacks");
    ListOfAttacks->ShareWith(InstanceArray[0]->ListOfAttacks);

    channel_initialised = new Place("channel_initialised");
    addSharedPtr(channel_initialised, "channel_initialised");
    channel_initialised->ShareWith(InstanceArray[0]->channel_initialised);

    maxDemands = new Place("maxDemands");
    addSharedPtr(maxDemands, "maxDemands");
    maxDemands->ShareWith(InstanceArray[0]->maxDemands);


    //Share state in submodels
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Channel_ID, Channel_ID);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->DemandSubmitted, DemandSubmitted);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->InitTokens, InitTokens);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Input, Input);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->ListOfAttacks, ListOfAttacks);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->channel_initialised, channel_initialised);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->maxDemands, maxDemands);
    }
    for (counter = 1; counter < NumModels; counter++) {
      InstanceArray[0]->Channel_ID->ShareWith(InstanceArray[counter]->Channel_ID);
      InstanceArray[0]->DemandSubmitted->ShareWith(InstanceArray[counter]->DemandSubmitted);
      InstanceArray[0]->InitTokens->ShareWith(InstanceArray[counter]->InitTokens);
      InstanceArray[0]->Input->ShareWith(InstanceArray[counter]->Input);
      InstanceArray[0]->ListOfAttacks->ShareWith(InstanceArray[counter]->ListOfAttacks);
      InstanceArray[0]->channel_initialised->ShareWith(InstanceArray[counter]->channel_initialised);
      InstanceArray[0]->maxDemands->ShareWith(InstanceArray[counter]->maxDemands);
    }
  }
  Setup("Malicious_Demands_Init");
}

SW_channelRJ__Rep1::~SW_channelRJ__Rep1() {
  if (NumModels == 0) return;
  delete Channel_ID;
  delete DemandSubmitted;
  delete InitTokens;
  delete Input;
  delete ListOfAttacks;
  delete channel_initialised;
  delete maxDemands;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

